## elpi 1.14.1

=== Makefile ===
help:
	@echo 'Known targets:'
	@echo
	@echo '  build            builds elpi'
	@echo '  install          install elpi'
	@echo '  clean            remove build artifacts'
	@echo
	@echo '  tests            runs the entire test suite'
	@echo '  tests ONLY=rex   runs only tests matching rex'
	@echo
	@echo '  git/treeish      checkout treeish and build elpi.git.treeish'
	@echo

INSTALL=_build/install/default
BUILD=_build/default
SHELL:=/usr/bin/env bash
TIMEOUT=90.0
PWD=$(shell pwd)
RUNNERS=\
  dune \
  $(PWD)/$(INSTALL)/bin/elpi \
  $(addprefix $(PWD)/,$(wildcard _build/git/*/$(INSTALL)/bin/elpi.git.*)) \
  $(shell if type tjsim >/dev/null 2>&1; then type -P tjsim; else echo; fi)
TIME=--time $(shell if type -P gtime >/dev/null 2>&1; then type -P gtime; else echo /usr/bin/time; fi)
STACK=1114112
DUNE_OPTS=

CP5:=$(shell ocamlfind query camlp5)

build:
	dune build $(DUNE_OPTS) @all
	# hack: link camlp5.gramlib in the plugin
	ocamlfind opt -shared -linkall -o _build/install/default/lib/elpi/elpi.cmxs \
		$(CP5)/gramlib.cmxa \
		_build/install/default/lib/elpi/elpi.cmxa


install:
	dune install $(DUNE_OPTS)

doc:
	dune build $(DUNE_OPTS) @doc

clean:
	rm -rf _build

tests:
	$(MAKE) build
	ulimit -s $(STACK); OCAMLRUNPARAM=l=$(STACK) \
		tests/test.exe \
		--seed $$RANDOM \
		--timeout $(TIMEOUT) \
		$(TIME) \
		--sources=$(PWD)/tests/sources/ \
		--plot=$(PWD)/tests/plot \
		$(addprefix --name-match ,$(ONLY)) \
		$(addprefix --runner , $(RUNNERS))

git/%:
	rm -rf "_build/git/elpi-$*"
	mkdir -p "_build/git/elpi-$*"
	git clone -l . "_build/git/elpi-$*"
	cd "_build/git/elpi-$*" && git checkout "$*"
	cd "_build/git/elpi-$*" && \
	  if [ -f dune ]; then \
	    make build DUNE_OPTS="$(DUNE_OPTS) --root .";\
	    cd _build/install/default/bin/; \
		ln -sf elpi elpi.git.$*; \
	  else \
	    make; \
		mkdir -p _build/install/default/bin/; \
		ln -s $$PWD/elpi _build/install/default/bin/elpi.git.$*; \
	  fi

.PHONY: tests help install build clean

=== debian/changelog ===
elpi (1.14.1-1) unstable; urgency=medium

  * Add a debian/upstream/metadata file.
  * New upstream release.

 -- Julien Puydt <jpuydt@debian.org>  Tue, 08 Feb 2022 22:05:04 +0100

elpi (1.13.8-2) unstable; urgency=medium

  * Add support for camlp5 8.*. (Closes: #1002988)

 -- Julien Puydt <jpuydt@debian.org>  Fri, 21 Jan 2022 10:22:17 +0100

elpi (1.13.8-1) unstable; urgency=medium

  * New upstream release.
  * Drop extra license files.
  * Add patch to fix typos.

 -- Julien Puydt <jpuydt@debian.org>  Mon, 29 Nov 2021 12:47:05 +0100

elpi (1.13.7-2) unstable; urgency=medium

  * Better packaging.

 -- Julien Puydt <jpuydt@debian.org>  Wed, 10 Nov 2021 18:46:46 +0100

elpi (1.13.7-1) unstable; urgency=medium

  * Initial release. (Closes: #997993)

 -- Julien Puydt <jpuydt@debian.org>  Fri, 29 Oct 2021 21:29:00 +0200

=== debian/control ===
Source: elpi
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Julien Puydt <jpuydt@debian.org>
Section: ocaml
Priority: optional
Standards-Version: 4.6.0
Rules-Requires-Root: no
Build-Depends: camlp5 (>= 8.00.02),
               debhelper-compat (= 13),
               dh-ocaml,
               libppx-deriving-ocaml-dev,
               libppxlib-ocaml-dev,
               libre-ocaml-dev,
               ocaml-dune
Vcs-Browser: https://salsa.debian.org/ocaml-team/elpi
Vcs-Git: https://salsa.debian.org/ocaml-team/elpi.git
Homepage: https://github.com/LPCIC/elpi

Package: libelpi-ocaml
Architecture: any
Depends: ${misc:Depends}, ${ocaml:Depends}, ${shlibs:Depends}
Provides: ${ocaml:Provides}
Recommends: ocaml-findlib
Description: embeddable lambda-Prolog interpreter (runtime files)
 ELPI implements a lambda-Prolog interpreter enriched with
 constraint handling rules, to provide an extension language
 to larger applications written in OCaml.
 .
 This package provides the runtime files.

Package: libelpi-ocaml-dev
Architecture: any
Depends: ${misc:Depends}, ${ocaml:Depends}, ${shlibs:Depends}
Provides: ${ocaml:Provides}
Recommends: ocaml-findlib
Description: embeddable lambda-Prolog interpreter (dev files)
 ELPI implements a lambda-Prolog interpreter enriched with
 constraint handling rules, to provide an extension language
 to larger applications written in OCaml.
 .
 This package provides the dev files.

Package: elpi
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, libelpi-ocaml (= ${binary:Version})
Description: embeddable lambda-Prolog interpreter (tool)
 ELPI implements a lambda-Prolog interpreter enriched with
 constraint handling rules, to provide an extension language
 to larger applications written in OCaml.
 .
 This package provides the command-line tool.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk
include /usr/share/ocaml/ocamlvars.mk

%:
	dh $@ --with ocaml

override_dh_auto_build:
	sed -e 's/%%VERSION_NUM%%/$(DEB_VERSION_UPSTREAM)/g' -i elpi_REPL.ml
	sed -e 's/%%VERSION_NUM%%/$(DEB_VERSION_UPSTREAM)/g' -i src/compiler.ml
	dune build @all

override_dh_auto_install:
	dune install --destdir=$(CURDIR)/debian/tmp --prefix=/usr --libdir=..$(OCAML_STDLIB_DIR)
	# drop excess LICENSE files
	find debian/tmp -name "LICENSE*" -delete
	# we detect what to ship
	find debian/tmp -regextype posix-awk \
	  -regex '.*\.(cma|cmxs)$$' \
	  >> debian/libelpi-ocaml.install
	find debian/tmp -regextype posix-awk \
	  -regex '.*\.(a|cmi|cmo|cmt|cmti|cmx|cmxa|ml|mli|o])$$' \
	  >> debian/libelpi-ocaml-dev.install

## elpi 1.16.5

=== Makefile ===
--- 
+++ 
@@ -1,14 +1,24 @@
 help:
-	@echo 'Known targets:'
+	@echo 'Build targets:'
 	@echo
 	@echo '  build            builds elpi'
 	@echo '  install          install elpi'
 	@echo '  clean            remove build artifacts'
+	@echo '  release          release the software (note: git tag -s first)'
+	@echo
+	@echo 'Testing targets:'
 	@echo
 	@echo '  tests            runs the entire test suite'
 	@echo '  tests ONLY=rex   runs only tests matching rex'
 	@echo
 	@echo '  git/treeish      checkout treeish and build elpi.git.treeish'
+	@echo
+	@echo 'Parser maintenance targets:'
+	@echo
+	@echo '  menhir-repl      run menhir in interactive mode'
+	@echo '  menhir-explain-conflicts'
+	@echo '  menhir-complete-errormsgs run when updating the grammar'
+	@echo '  menhir-strip-errormsgs remove comments from error message file'
 	@echo
 
 INSTALL=_build/install/default
@@ -19,21 +29,22 @@
 RUNNERS=\
   dune \
   $(PWD)/$(INSTALL)/bin/elpi \
+  $(PWD)/$(INSTALL)/bin/elpi-trace-elaborator \
   $(addprefix $(PWD)/,$(wildcard _build/git/*/$(INSTALL)/bin/elpi.git.*)) \
   $(shell if type tjsim >/dev/null 2>&1; then type -P tjsim; else echo; fi)
 TIME=--time $(shell if type -P gtime >/dev/null 2>&1; then type -P gtime; else echo /usr/bin/time; fi)
 STACK=1114112
+
 DUNE_OPTS=
-
-CP5:=$(shell ocamlfind query camlp5)
 
 build:
 	dune build $(DUNE_OPTS) @all
-	# hack: link camlp5.gramlib in the plugin
-	ocamlfind opt -shared -linkall -o _build/install/default/lib/elpi/elpi.cmxs \
-		$(CP5)/gramlib.cmxa \
-		_build/install/default/lib/elpi/elpi.cmxa
 
+config:
+	@(if [ -z $$LEGACY_PARSER ]; \
+	then echo '(dirs :standard \ legacy_parser)'; \
+	else echo '(dirs :standard )'; \
+	fi ) > src/dune.config
 
 install:
 	dune install $(DUNE_OPTS)
@@ -44,8 +55,13 @@
 clean:
 	rm -rf _build
 
+release:
+	dune-release -p elpi
+
+# testing
 tests:
 	$(MAKE) build
+	dune runtest
 	ulimit -s $(STACK); OCAMLRUNPARAM=l=$(STACK) \
 		tests/test.exe \
 		--seed $$RANDOM \
@@ -54,6 +70,7 @@
 		--sources=$(PWD)/tests/sources/ \
 		--plot=$(PWD)/tests/plot \
 		$(addprefix --name-match ,$(ONLY)) \
+		$(addprefix --cat-skip ,$(SKIP)) \
 		$(addprefix --runner , $(RUNNERS))
 
 git/%:
@@ -72,4 +89,30 @@
 		ln -s $$PWD/elpi _build/install/default/bin/elpi.git.$*; \
 	  fi
 
+# parser maintenance
+menhir-repl:
+	menhir --interpret src/parser/tokens.mly \
+		src/parser/token_precedence.mly \
+		--base grammar src/parser/grammar.mly 2>/dev/null
+menhir-explain-conflicts:
+	-menhir --explain src/parser/tokens.mly \
+		src/parser/token_precedence.mly \
+		--base grammar src/parser/grammar.mly
+	echo "Plese look at grammar.conflicts"
+menhir-complete-errormsgs:
+	menhir src/parser/tokens.mly \
+		src/parser/token_precedence.mly \
+		--base grammar src/parser/grammar.mly \
+		--list-errors > src/parser/error_messages.auto.messages
+	menhir src/parser/tokens.mly \
+		src/parser/token_precedence.mly \
+		--base grammar src/parser/grammar.mly\
+		--merge-errors src/parser/error_messages.auto.messages \
+		--merge-errors src/parser/error_messages.txt \
+		> src/parser/error_messages.merged
+	mv src/parser/error_messages.merged src/parser/error_messages.txt
+	rm src/parser/error_messages.auto.messages
+menhir-strip-errormsgs:
+	sed -e "/^##/d" -i.bak src/parser/error_messages.txt
+
 .PHONY: tests help install build clean

=== debian/changelog ===
elpi (1.16.5-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.6.1.

 -- Julien Puydt <jpuydt@debian.org>  Sun, 17 Jul 2022 12:30:29 +0200

elpi (1.15.2-1) unstable; urgency=medium

  * New upstream release.

 -- Julien Puydt <jpuydt@debian.org>  Sat, 14 May 2022 04:06:35 +0200

elpi (1.14.3-1) unstable; urgency=medium

  * New upstream release.
  * Drop patch (obsolete).

 -- Julien Puydt <jpuydt@debian.org>  Fri, 25 Mar 2022 07:47:24 +0100

=== debian/control ===
--- 
+++ 
@@ -3,14 +3,18 @@
 Uploaders: Julien Puydt <jpuydt@debian.org>
 Section: ocaml
 Priority: optional
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
-Build-Depends: camlp5 (>= 8.00.02),
+Build-Depends: atdts (>= 2.9.1),
+               camlp5 (>= 8.00.02),
                debhelper-compat (= 13),
                dh-ocaml,
+               libatdgen-ocaml-dev (>= 2.9.1),
+               libmenhir-ocaml-dev,
                libppx-deriving-ocaml-dev,
                libppxlib-ocaml-dev,
                libre-ocaml-dev,
+               menhir,
                ocaml-dune
 Vcs-Browser: https://salsa.debian.org/ocaml-team/elpi
 Vcs-Git: https://salsa.debian.org/ocaml-team/elpi.git
@@ -42,7 +46,9 @@
 
 Package: elpi
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}, libelpi-ocaml (= ${binary:Version})
+Depends: libelpi-ocaml (= ${binary:Version}),
+         ${misc:Depends},
+         ${shlibs:Depends}
 Description: embeddable lambda-Prolog interpreter (tool)
  ELPI implements a lambda-Prolog interpreter enriched with
  constraint handling rules, to provide an extension language

=== debian/rules ===
--- 
+++ 
@@ -15,6 +15,8 @@
 	dune install --destdir=$(CURDIR)/debian/tmp --prefix=/usr --libdir=..$(OCAML_STDLIB_DIR)
 	# drop excess LICENSE files
 	find debian/tmp -name "LICENSE*" -delete
+	# drop legacy stuff
+	rm -rf debian/tmp/usr/doc/elpi-option-legacy-parser debian/tmp/usr/lib/ocaml/elpi-option-legacy-parser
 	# we detect what to ship
 	find debian/tmp -regextype posix-awk \
 	  -regex '.*\.(cma|cmxs)$$' \

## elpi 1.16.8

=== Makefile ===
--- 
+++ 
@@ -52,11 +52,33 @@
 doc:
 	dune build $(DUNE_OPTS) @doc
 
+doc-build: doc
+	rm -rf docs/build
+	rm -rf docs/source
+	cp -r docs/base docs/source
+	sed -i "s/@@VERSION@@/$(shell git describe)/" docs/source/conf.py
+	python3 docs/engine/engine.py
+	cd docs && make html
+	cp -r _build/default/_doc/_html/elpi docs/build/html/
+	cp -r _build/default/_doc/_html/elpi-option-legacy-parser docs/build/html/
+	cp -r _build/default/_doc/_html/highlight.pack.js docs/build/html/
+	cp -r _build/default/_doc/_html/odoc.css docs/build/html/
+	touch docs/build/html/.nojekyll
+
+doc-publish: doc-build
+	rm -rf /tmp/gh-pages
+	cp -r docs/build/html/ /tmp/gh-pages
+	OLD_BRANCH=`git branch --show-current`; \
+	git checkout gh-pages && rm -rf * && cp -r /tmp/gh-pages/* ./ && rm -rf /tmp/gh-pages && git add . && git commit -m "Updated gh-pages" && git checkout $$OLD_BRANCH
+	@echo "uploading: enter to continue, ^C to abort"; read DUMMY; git push origin gh-pages
+
 clean:
 	rm -rf _build
+	rm -rf docs/build
 
 release:
 	dune-release -p elpi
+	$(MAKE) doc-publish
 
 # testing
 tests:
@@ -115,4 +137,4 @@
 menhir-strip-errormsgs:
 	sed -e "/^##/d" -i.bak src/parser/error_messages.txt
 
-.PHONY: tests help install build clean
+.PHONY: tests help install build clean gh-pages

=== debian/changelog ===
elpi (1.16.8-1) unstable; urgency=medium

  * Re-enable the archv64 architecture following advice from
  Manuel A. Fernandez Montecelo - thanks! (Closes: #1025129)
  * New upstream release.
  * Drop the patch for yojson 2.0 support (obsolete).

 -- Julien Puydt <jpuydt@debian.org>  Wed, 07 Dec 2022 08:21:57 +0100

elpi (1.16.7-2) unstable; urgency=medium

  * Limit the architectures where the package builds,
    until upstream re-enables them.

 -- Julien Puydt <jpuydt@debian.org>  Wed, 26 Oct 2022 11:11:53 +0200

elpi (1.16.7-1) unstable; urgency=medium

  * New upstream release.
  * Add patch for yojson 2.0 support.

 -- Julien Puydt <jpuydt@debian.org>  Mon, 24 Oct 2022 13:38:28 +0200

elpi (1.16.5-4) unstable; urgency=medium

  * Add patch for longer timeouts, so tests pass on
  more architectures.

 -- Julien Puydt <jpuydt@debian.org>  Tue, 13 Sep 2022 08:52:43 +0200

elpi (1.16.5-3) unstable; urgency=medium

  * Add more deps to help with running tests on several architectures.

 -- Julien Puydt <jpuydt@debian.org>  Mon, 12 Sep 2022 14:41:30 +0200

elpi (1.16.5-2) unstable; urgency=medium

  * Enable tests during the compilation.

 -- Julien Puydt <jpuydt@debian.org>  Mon, 12 Sep 2022 13:52:08 +0200

=== debian/control ===
--- 
+++ 
@@ -9,19 +9,24 @@
                camlp5 (>= 8.00.02),
                debhelper-compat (= 13),
                dh-ocaml,
+               gnuplot,
+               libansi-terminal-ocaml-dev,
                libatdgen-ocaml-dev (>= 2.9.1),
+               libcmdliner-ocaml-dev,
                libmenhir-ocaml-dev,
                libppx-deriving-ocaml-dev,
                libppxlib-ocaml-dev,
                libre-ocaml-dev,
+               lua5.1,
                menhir,
-               ocaml-dune
+               ocaml-dune,
+               time
 Vcs-Browser: https://salsa.debian.org/ocaml-team/elpi
 Vcs-Git: https://salsa.debian.org/ocaml-team/elpi.git
 Homepage: https://github.com/LPCIC/elpi
 
 Package: libelpi-ocaml
-Architecture: any
+Architecture: amd64 arm64 i386 ppc64el ppc64 riscv64 sh4
 Depends: ${misc:Depends}, ${ocaml:Depends}, ${shlibs:Depends}
 Provides: ${ocaml:Provides}
 Recommends: ocaml-findlib
@@ -33,7 +38,7 @@
  This package provides the runtime files.
 
 Package: libelpi-ocaml-dev
-Architecture: any
+Architecture: amd64 arm64 i386 ppc64el ppc64 riscv64 sh4
 Depends: ${misc:Depends}, ${ocaml:Depends}, ${shlibs:Depends}
 Provides: ${ocaml:Provides}
 Recommends: ocaml-findlib
@@ -45,7 +50,7 @@
  This package provides the dev files.
 
 Package: elpi
-Architecture: any
+Architecture: amd64 arm64 i386 ppc64el ppc64 riscv64 sh4
 Depends: libelpi-ocaml (= ${binary:Version}),
          ${misc:Depends},
          ${shlibs:Depends}

=== debian/rules ===
--- 
+++ 
@@ -9,7 +9,10 @@
 override_dh_auto_build:
 	sed -e 's/%%VERSION_NUM%%/$(DEB_VERSION_UPSTREAM)/g' -i elpi_REPL.ml
 	sed -e 's/%%VERSION_NUM%%/$(DEB_VERSION_UPSTREAM)/g' -i src/compiler.ml
-	dune build @all
+	make build
+
+override_dh_auto_test:
+	make tests
 
 override_dh_auto_install:
 	dune install --destdir=$(CURDIR)/debian/tmp --prefix=/usr --libdir=..$(OCAML_STDLIB_DIR)

## elpi 1.17.0

=== debian/changelog ===
elpi (1.17.0-1build4) mantic; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 28 Aug 2023 15:49:46 +0200

elpi (1.17.0-1build3) mantic; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 20 Aug 2023 09:33:42 +0200

elpi (1.17.0-1build2) mantic; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 28 Jul 2023 05:34:34 +0200

elpi (1.17.0-1build1) mantic; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 27 Jul 2023 11:44:26 +0200

elpi (1.17.0-1) unstable; urgency=medium

  * New upstream release.

 -- Julien Puydt <jpuydt@debian.org>  Tue, 25 Jul 2023 13:21:26 +0200

elpi (1.16.10-3) unstable; urgency=medium

  * Team upload
  * Force STACK to a higher value for tests (Closes: #1040541)

 -- Stéphane Glondu <glondu@debian.org>  Wed, 12 Jul 2023 12:22:35 +0200

elpi (1.16.10-2) unstable; urgency=medium

  * Fix compilation with recent dune.

 -- Julien Puydt <jpuydt@debian.org>  Thu, 06 Jul 2023 14:44:19 +0200

elpi (1.16.10-1) unstable; urgency=medium

  * New upstream release.
  * Bump standards-version to 4.6.2.

 -- Julien Puydt <jpuydt@debian.org>  Mon, 12 Jun 2023 08:54:50 +0200

=== debian/control ===
--- 
+++ 
@@ -3,13 +3,13 @@
 Uploaders: Julien Puydt <jpuydt@debian.org>
 Section: ocaml
 Priority: optional
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Build-Depends: atdts (>= 2.9.1),
                camlp5 (>= 8.00.02),
                debhelper-compat (= 13),
                dh-ocaml,
-               gnuplot,
+               gnuplot-nox,
                libansi-terminal-ocaml-dev,
                libatdgen-ocaml-dev (>= 2.9.1),
                libcmdliner-ocaml-dev,

=== debian/rules ===
--- 
+++ 
@@ -12,10 +12,10 @@
 	make build
 
 override_dh_auto_test:
-	make tests
+	make tests STACK=11141120
 
 override_dh_auto_install:
-	dune install --destdir=$(CURDIR)/debian/tmp --prefix=/usr --libdir=..$(OCAML_STDLIB_DIR)
+	dune install --destdir=$(CURDIR)/debian/tmp --prefix=/usr --libdir=$(OCAML_STDLIB_DIR)
 	# drop excess LICENSE files
 	find debian/tmp -name "LICENSE*" -delete
 	# drop legacy stuff

## elpi 1.17.4

=== Makefile ===
--- 
+++ 
@@ -59,10 +59,7 @@
 	sed -i "s/@@VERSION@@/$(shell git describe)/" docs/source/conf.py
 	python3 docs/engine/engine.py
 	cd docs && make html
-	cp -r _build/default/_doc/_html/elpi docs/build/html/
-	cp -r _build/default/_doc/_html/elpi-option-legacy-parser docs/build/html/
-	cp -r _build/default/_doc/_html/highlight.pack.js docs/build/html/
-	cp -r _build/default/_doc/_html/odoc.css docs/build/html/
+	cp -r _build/default/_doc/_html/* docs/build/html/
 	touch docs/build/html/.nojekyll
 
 doc-publish: doc-build

=== tests/sources/lyp/Makefile ===
H = @

ENGINE = lyp_engine.elpi
EXPORT = export-lyp

ELPI       = elpi
HELENA_DIR = helena

TEMP = etc/temp.txt
TEST = etc/test_31.txt

all:

clean:
	$(H)$(RM) -f *~

test-tc:
	$(H)$(ELPI) -test $(ENGINE)

test:
	$(H)$(ELPI) -no-tc -test $(ENGINE)

test-31:
	$(H)mkdir -p etc 
	$(H)$(RM) $(TEMP)
	$(H)for RUN in `seq 1 31`; do $(ELPI) -no-tc -test $(ENGINE) 2>> $(TEMP); done
	$(H)echo `hostname` `date` > $(TEST)
	$(H)echo >> $(TEST)
	$(H)grep "Time: " $(TEMP) | sort -n -k 2 | cat -n >> $(TEST)

helena:
	$(H)$(MAKE) --no-print-directory -C $(HELENA_DIR) $(EXPORT)

.PHONY: helena

=== debian/changelog ===
elpi (1.17.4-3build1) noble; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 17 Feb 2024 01:22:51 +0100

elpi (1.17.4-3) unstable; urgency=medium

  * Really re-enable all architectures... shame!

 -- Julien Puydt <jpuydt@debian.org>  Sun, 31 Dec 2023 19:14:29 +0100

elpi (1.17.4-2) unstable; urgency=medium

  * Re-enable all architectures (just to see).

 -- Julien Puydt <jpuydt@debian.org>  Sun, 31 Dec 2023 12:39:20 +0100

elpi (1.17.4-1) unstable; urgency=medium

  [ Julien Puydt ]
  * Fix d/rules cleaning (Closes: #1044961).

  [ Stéphane Glondu ]
  * Use ocaml_dune DH buildsystem
  * Mark test-only dependencies with <!nocheck>

  [ Debian Janitor ]
  * debian/copyright: use spaces rather than tabs to start continuation lines.

  [ Julien Puydt ]
  * New upstream release.

 -- Julien Puydt <jpuydt@debian.org>  Thu, 21 Dec 2023 14:45:57 +0100

=== debian/control ===
--- 
+++ 
@@ -8,11 +8,11 @@
 Build-Depends: atdts (>= 2.9.1),
                camlp5 (>= 8.00.02),
                debhelper-compat (= 13),
-               dh-ocaml,
+               dh-ocaml (>= 1.2),
                gnuplot-nox,
-               libansi-terminal-ocaml-dev,
+               libansi-terminal-ocaml-dev <!nocheck>,
                libatdgen-ocaml-dev (>= 2.9.1),
-               libcmdliner-ocaml-dev,
+               libcmdliner-ocaml-dev <!nocheck>,
                libmenhir-ocaml-dev,
                libppx-deriving-ocaml-dev,
                libppxlib-ocaml-dev,
@@ -26,7 +26,7 @@
 Homepage: https://github.com/LPCIC/elpi
 
 Package: libelpi-ocaml
-Architecture: amd64 arm64 i386 ppc64el ppc64 riscv64 sh4
+Architecture: any
 Depends: ${misc:Depends}, ${ocaml:Depends}, ${shlibs:Depends}
 Provides: ${ocaml:Provides}
 Recommends: ocaml-findlib
@@ -38,7 +38,7 @@
  This package provides the runtime files.
 
 Package: libelpi-ocaml-dev
-Architecture: amd64 arm64 i386 ppc64el ppc64 riscv64 sh4
+Architecture: any
 Depends: ${misc:Depends}, ${ocaml:Depends}, ${shlibs:Depends}
 Provides: ${ocaml:Provides}
 Recommends: ocaml-findlib
@@ -50,7 +50,7 @@
  This package provides the dev files.
 
 Package: elpi
-Architecture: amd64 arm64 i386 ppc64el ppc64 riscv64 sh4
+Architecture: any
 Depends: libelpi-ocaml (= ${binary:Version}),
          ${misc:Depends},
          ${shlibs:Depends}

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/pkg-info.mk
include /usr/share/ocaml/ocamlvars.mk

%:
	dh $@ --with ocaml --buildsystem ocaml_dune

execute_before_dh_auto_build:
	cp elpi_REPL.ml elpi_REPL.ml.orig
	sed -e 's/%%VERSION_NUM%%/$(DEB_VERSION_UPSTREAM)/g' -i elpi_REPL.ml
	cp src/compiler.ml src/compiler.ml.orig
	sed -e 's/%%VERSION_NUM%%/$(DEB_VERSION_UPSTREAM)/g' -i src/compiler.ml
	cp src/trace_atd.ts src/trace_atd.ts.orig

override_dh_auto_test:
	make tests STACK=11141120

execute_after_dh_auto_install:
	# drop excess LICENSE files
	find debian/tmp -name "LICENSE*" -delete
	# we detect what to ship
	find debian/tmp -regextype posix-awk \
	  -regex '.*\.(cma|cmxs)$$' \
	  >> debian/libelpi-ocaml.install
	find debian/tmp -regextype posix-awk \
	  -regex '.*\.(a|cmi|cmo|cmt|cmti|cmx|cmxa|ml|mli|o])$$' \
	  >> debian/libelpi-ocaml-dev.install

execute_after_dh_auto_clean:
	rm -rf _log/ tests/test.exe data.csv*
	if test -f elpi_REPL.ml.orig; then \
	  mv elpi_REPL.ml.orig elpi_REPL.ml; \
	fi
	if test -f src/compiler.ml.orig; then \
	  mv src/compiler.ml.orig src/compiler.ml; \
	fi
	if test -f src/trace_atd.ts.orig; then \
	  mv src/trace_atd.ts.orig src/trace_atd.ts; \
	fi

## elpi 1.18.2

=== Makefile ===
--- 
+++ 
@@ -39,12 +39,6 @@
 
 build:
 	dune build $(DUNE_OPTS) @all
-
-config:
-	@(if [ -z $$LEGACY_PARSER ]; \
-	then echo '(dirs :standard \ legacy_parser)'; \
-	else echo '(dirs :standard )'; \
-	fi ) > src/dune.config
 
 install:
 	dune install $(DUNE_OPTS)

=== debian/changelog ===
elpi (1.18.2-5build3) oracular; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 17 Sep 2024 14:39:47 +0200

elpi (1.18.2-5build2) oracular; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 11 Sep 2024 21:48:49 +0200

elpi (1.18.2-5build1) oracular; urgency=medium

  * No-change rebuild for OCaml ABIs.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 07 Sep 2024 00:44:45 +0200

elpi (1.18.2-5) unstable; urgency=medium

  * Team upload
  * Simplify architectures: declare binaries "Architecture: any" and
    build-depend on ocaml-native-compilers

 -- Stéphane Glondu <glondu@debian.org>  Sat, 10 Aug 2024 09:36:00 +0200

elpi (1.18.2-4) unstable; urgency=medium

  * Add autopkgtest.

 -- Julien Puydt <jpuydt@debian.org>  Tue, 18 Jun 2024 11:37:00 +0200

elpi (1.18.2-3) unstable; urgency=medium

  * Add missing depend on yojson-tools (Closes: #1073275).

 -- Julien Puydt <jpuydt@debian.org>  Sun, 16 Jun 2024 18:26:35 +0200

elpi (1.18.2-2) unstable; urgency=medium

  * Team upload
  * Add armhf and s390x to Architectures

 -- Stéphane Glondu <glondu@debian.org>  Fri, 07 Jun 2024 06:54:50 +0200

elpi (1.18.2-1) unstable; urgency=medium

  * New upstream release.

 -- Julien Puydt <jpuydt@debian.org>  Sat, 24 Feb 2024 09:49:22 +0100

elpi (1.18.1-1) unstable; urgency=medium

  [ Julien Puydt ]
  * Fix d/rules cleaning (Closes: #1044961).

  [ Stéphane Glondu ]
  * Use ocaml_dune DH buildsystem
  * Mark test-only dependencies with <!nocheck>

  [ Debian Janitor ]
  * debian/copyright: use spaces rather than tabs to start continuation lines.

  [ Julien Puydt ]
  * New upstream release.
  * Add support for loong64 architecture (Closes: #1059090).

 -- Julien Puydt <jpuydt@debian.org>  Thu, 25 Jan 2024 06:31:26 +0100

=== debian/control ===
--- 
+++ 
@@ -19,8 +19,10 @@
                libre-ocaml-dev,
                lua5.1,
                menhir,
+               ocaml-native-compilers,
                ocaml-dune,
-               time
+               time,
+               yojson-tools
 Vcs-Browser: https://salsa.debian.org/ocaml-team/elpi
 Vcs-Git: https://salsa.debian.org/ocaml-team/elpi.git
 Homepage: https://github.com/LPCIC/elpi

## elpi 2.0.5

=== debian/changelog ===
elpi (2.0.5-1) unstable; urgency=medium

  * New upstream release.
  * Bump standards-version to 4.7.0.

 -- Julien Puydt <jpuydt@debian.org>  Wed, 18 Dec 2024 12:07:57 +0100

elpi (1.19.6-1) unstable; urgency=medium

  * New upstream release.

 -- Julien Puydt <jpuydt@debian.org>  Wed, 20 Nov 2024 10:40:19 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Uploaders: Julien Puydt <jpuydt@debian.org>
 Section: ocaml
 Priority: optional
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Build-Depends: atdts (>= 2.9.1),
                camlp5 (>= 8.00.02),
@@ -13,6 +13,7 @@
                libansi-terminal-ocaml-dev <!nocheck>,
                libatdgen-ocaml-dev (>= 2.9.1),
                libcmdliner-ocaml-dev <!nocheck>,
+               libfileutils-ocaml-dev <!nocheck>,
                libmenhir-ocaml-dev,
                libppx-deriving-ocaml-dev,
                libppxlib-ocaml-dev,

=== debian/rules ===
--- 
+++ 
@@ -10,8 +10,8 @@
 execute_before_dh_auto_build:
 	cp elpi_REPL.ml elpi_REPL.ml.orig
 	sed -e 's/%%VERSION_NUM%%/$(DEB_VERSION_UPSTREAM)/g' -i elpi_REPL.ml
-	cp src/compiler.ml src/compiler.ml.orig
-	sed -e 's/%%VERSION_NUM%%/$(DEB_VERSION_UPSTREAM)/g' -i src/compiler.ml
+	cp src/compiler/compiler.ml src/compiler/compiler.ml.orig
+	sed -e 's/%%VERSION_NUM%%/$(DEB_VERSION_UPSTREAM)/g' -i src/compiler/compiler.ml
 	cp src/trace_atd.ts src/trace_atd.ts.orig
 
 override_dh_auto_test:
@@ -19,7 +19,10 @@
 
 execute_after_dh_auto_install:
 	# drop excess LICENSE files
-	find debian/tmp -name "LICENSE*" -delete
+	rm -f debian/tmp/usr/doc/elpi/LICENSE
+	# don't declare the documentation files as part of the package
+	find debian/tmp -name dune-package | xargs sed -i -e "s|(doc[^()]*([^()]*))||g"
+	find debian/tmp -name dune-package | xargs sed -i -e "s|(doc[^()]*)||g"
 	# we detect what to ship
 	find debian/tmp -regextype posix-awk \
 	  -regex '.*\.(cma|cmxs)$$' \
@@ -33,8 +36,8 @@
 	if test -f elpi_REPL.ml.orig; then \
 	  mv elpi_REPL.ml.orig elpi_REPL.ml; \
 	fi
-	if test -f src/compiler.ml.orig; then \
-	  mv src/compiler.ml.orig src/compiler.ml; \
+	if test -f src/compiler/compiler.ml.orig; then \
+	  mv src/compiler/compiler.ml.orig src/compiler/compiler.ml; \
 	fi
 	if test -f src/trace_atd.ts.orig; then \
 	  mv src/trace_atd.ts.orig src/trace_atd.ts; \

## elpi 2.0.7

=== debian/changelog ===
elpi (2.0.7-1) unstable; urgency=medium

  * New upstream release.

 -- Julien Puydt <jpuydt@debian.org>  Sat, 15 Feb 2025 15:20:02 +0100

elpi (2.0.5-2) unstable; urgency=medium

  * Team upload
  * Fix compilation with atdgen 2.16

 -- Stéphane Glondu <glondu@debian.org>  Thu, 13 Feb 2025 14:16:30 +0100

=== debian/tests/control ===
Tests: testsuite
Depends: ocaml-dune, @
Restrictions: allow-stderr

=== debian/watch ===
version=4
https://github.com/LPCIC/elpi/tags .*/v?([\d\.]+).tar.gz

## elpi 3.3.1

=== debian/changelog ===
elpi (3.3.1-1) experimental; urgency=medium

  * New upstream release.
  * Drop now-unneeded patch for compilation with recent atdgen.

 -- Julien Puydt <jpuydt@debian.org>  Wed, 17 Sep 2025 06:48:20 +0200

elpi (2.0.7-2) unstable; urgency=medium

  * Team upload
  * Fix compilation with ppxlib 0.36.0 (Closes: #1114903)

 -- Stéphane Glondu <glondu@debian.org>  Thu, 11 Sep 2025 15:27:16 +0200

## elpi 3.4.2

=== Makefile ===
--- 
+++ 
@@ -1,21 +1,26 @@
 help:
 	@echo 'Build targets:'
 	@echo
-	@echo '  build            builds elpi'
-	@echo '  install          install elpi'
-	@echo '  clean            remove build artifacts'
-	@echo '  release          release the software (note: git tag -s first)'
+	@echo '  build                  builds elpi'
+	@echo '  install                install elpi'
+	@echo '  clean                  remove build artifacts'
+	@echo '  release                release the software (note: git tag -s first)'
 	@echo
 	@echo 'Testing targets:'
 	@echo
-	@echo '  tests            runs the entire test suite'
-	@echo '  tests ONLY=rex   runs only tests matching rex'
+	@echo '  tests                  runs the entire test suite'
+	@echo '  tests ONLY=rex         runs only tests matching rex'
+	@echo '  tests PROMOTE=true     runs and promote tests if different'
+	@echo '                           (can be combined with ONLY)'
+	@echo '  tests LN_NB=nb         sets max number of lines to print of failing tests'
+	@echo '                           (negave numbers means print all file)'
+	@echo '  tests STOP_ON_FST_ERROR=true stops the test suite after first error'
 	@echo
-	@echo '  git/treeish      checkout treeish and build elpi.git.treeish'
+	@echo '  git/treeish            checkout treeish and build elpi.git.treeish'
 	@echo
 	@echo 'Parser maintenance targets:'
 	@echo
-	@echo '  menhir-repl      run menhir in interactive mode'
+	@echo '  menhir-repl            run menhir in interactive mode'
 	@echo '  menhir-explain-conflicts'
 	@echo '  menhir-complete-errormsgs run when updating the grammar'
 	@echo '  menhir-strip-errormsgs remove comments from error message file'
@@ -25,9 +30,13 @@
 BUILD=_build/default
 SHELL:=/usr/bin/env bash
 TIMEOUT=90.0
+PROMOTE=false
+LN_NB=-1
+STOP_ON_FST_ERROR=false
 PWD=$(shell pwd)
 RUNNERS=\
-  dune \
+  $(wildcard $(PWD)/_build/git/*/$(BUILD)/tests/sources/*.exe.git.*.exe) \
+  $(wildcard $(PWD)/$(BUILD)/tests/sources/*.exe) \
   $(PWD)/$(INSTALL)/bin/elpi \
   $(PWD)/$(INSTALL)/bin/elpi-trace-elaborator \
   $(addprefix $(PWD)/,$(wildcard _build/git/*/$(INSTALL)/bin/elpi.git.*)) \
@@ -78,7 +87,10 @@
 	ulimit -s $(STACK); OCAMLRUNPARAM=l=$(STACK) \
 		tests/test.exe \
 		--seed $$RANDOM \
+		--promote $(PROMOTE) \
+		--ln_nb=$(LN_NB) \
 		--timeout $(TIMEOUT) \
+		--stop-on-first-error=$(STOP_ON_FST_ERROR) \
 		$(TIME) \
 		--sources=$(PWD)/tests/sources/ \
 		--plot=$(PWD)/tests/plot \
@@ -94,8 +106,8 @@
 	cd "_build/git/elpi-$*" && \
 	  if [ -f dune ]; then \
 	    make build DUNE_OPTS="$(DUNE_OPTS) --root .";\
-	    cd _build/install/default/bin/; \
-		ln -sf elpi elpi.git.$*; \
+	    (cd _build/install/default/bin/; ln -sf elpi elpi.git.$*); \
+	    (cd _build/default/tests/sources; for x in *.exe; do ln -sf $$x $$x.git.$*.exe; done) \
 	  else \
 	    make; \
 		mkdir -p _build/install/default/bin/; \

=== tests/sources/ld-3C/Makefile ===
H = @

ELPI = elpi

all:

test:
	$(H)$(ELPI) -no-tc -test ld3c_engine.elpi

test-tc:
	$(H)$(ELPI) -test ld3c_engine.elpi

=== debian/changelog ===
elpi (3.4.2-1) experimental; urgency=medium

  * New upstream release.

 -- Julien Puydt <jpuydt@debian.org>  Wed, 29 Oct 2025 00:17:18 +0100

=== debian/control ===
--- 
+++ 
@@ -3,12 +3,13 @@
 Uploaders: Julien Puydt <jpuydt@debian.org>
 Section: ocaml
 Priority: optional
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Build-Depends: atdts (>= 2.9.1),
                camlp5 (>= 8.00.02),
                debhelper-compat (= 13),
                dh-ocaml (>= 1.2),
+               git,
                gnuplot-nox,
                libansi-terminal-ocaml-dev <!nocheck>,
                libatdgen-ocaml-dev (>= 2.9.1),
@@ -16,7 +17,8 @@
                libfileutils-ocaml-dev <!nocheck>,
                libmenhir-ocaml-dev,
                libppx-deriving-ocaml-dev,
-               libppxlib-ocaml-dev,
+               libppxlib-ocaml-dev (>= 0.36.0),
+               libppx-optcomp-ocaml-dev,
                libre-ocaml-dev,
                lua5.1,
                menhir,

=== debian/rules ===
--- 
+++ 
@@ -4,18 +4,29 @@
 include /usr/share/dpkg/pkg-info.mk
 include /usr/share/ocaml/ocamlvars.mk
 
+export DEB_BUILD_OPTIONS += noautodbgsym
+
 %:
 	dh $@ --with ocaml --buildsystem ocaml_dune
 
 execute_before_dh_auto_build:
-	cp elpi_REPL.ml elpi_REPL.ml.orig
-	sed -e 's/%%VERSION_NUM%%/$(DEB_VERSION_UPSTREAM)/g' -i elpi_REPL.ml
-	cp src/compiler/compiler.ml src/compiler/compiler.ml.orig
-	sed -e 's/%%VERSION_NUM%%/$(DEB_VERSION_UPSTREAM)/g' -i src/compiler/compiler.ml
 	cp src/trace_atd.ts src/trace_atd.ts.orig
+	if test -f .git; then \
+	  @echo "Found .git, ok"; \
+        else \
+          touch .false_git; \
+          git init --initial-branch=main; \
+	  git config user.email "foo@bar.baz"; \
+	  git config user.name "Foo Bar"; \
+          git add dune; \
+          git commit -m foo; \
+          git tag -a v$(DEB_VERSION_UPSTREAM) -m foo; \
+        fi
 
 override_dh_auto_test:
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	make tests STACK=11141120
+endif
 
 execute_after_dh_auto_install:
 	# drop excess LICENSE files
@@ -33,12 +44,9 @@
 
 execute_after_dh_auto_clean:
 	rm -rf _log/ tests/test.exe data.csv*
-	if test -f elpi_REPL.ml.orig; then \
-	  mv elpi_REPL.ml.orig elpi_REPL.ml; \
-	fi
-	if test -f src/compiler/compiler.ml.orig; then \
-	  mv src/compiler/compiler.ml.orig src/compiler/compiler.ml; \
-	fi
 	if test -f src/trace_atd.ts.orig; then \
 	  mv src/trace_atd.ts.orig src/trace_atd.ts; \
 	fi
+	if test -f .false_git; then \
+	  rm -rf .false_git .git; \
+	fi

## elpi 3.4.3

=== tests/sources/helena_elpi/Makefile ===
H = @

ENGINE = ld3_engine.elpi
EXPORT = export-lp2

ELPI       = ../../../elpi
HELENA_DIR = helena

TEMP = etc/temp.txt
TEST = etc/test_31.txt

all:

clean:
	$(H)$(RM) -f *~

test-tc:
	$(H)$(ELPI) -test $(ENGINE)

test:
	$(H)$(ELPI) -no-tc -test $(ENGINE)

test-31:
	$(H)mkdir -p etc 
	$(H)$(RM) $(TEMP)
	$(H)for RUN in `seq 1 31`; do $(ELPI) -no-tc -test $(ENGINE) 2>> $(TEMP); done
	$(H)echo `hostname` `date` > $(TEST)
	$(H)echo >> $(TEST)
	$(H)grep "Time: " $(TEMP) | sort -n -k 2 | cat -n >> $(TEST)

helena:
	$(H)$(MAKE) --no-print-directory -C $(HELENA_DIR) $(EXPORT)

.PHONY: helena

=== debian/changelog ===
elpi (3.4.3-1) experimental; urgency=medium

  * New upstream release.

 -- Julien Puydt <jpuydt@debian.org>  Tue, 11 Nov 2025 18:08:22 +0100
